Unit Font7x5;

{ WolfEnstein clone - with 3D Texture mapping

Copyright (C) 1997 TothPaul@mygale.org
 http://www.mygale.org/~TothPaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

interface

{$R-,S-,I-,Q-}

function outtext(ix,iy:word;s:string):integer;

implementation

Const
 TextColor=15;
 BackColor=1;

Type
 TChar=record
  Data:Array[1..7] of byte;
  Size:byte;
 end;

const
 Font:array[#0..#255] of TChar=(
  {00h} (Data:($02,$02,$02,$02,$02,$02,$02); Size:$80),
  {01h} (Data:($4E,$51,$5B,$51,$55,$51,$4E); Size:$86),
  {02h} (Data:($4E,$5F,$55,$5F,$5F,$5B,$4E); Size:$86),
  {03h} (Data:($40,$4A,$5F,$5F,$4E,$44,$40); Size:$86),
  {04h} (Data:($40,$44,$4E,$5F,$4E,$44,$40); Size:$86),
  {05h} (Data:($40,$44,$44,$5F,$44,$4E,$40); Size:$86),
  {06h} (Data:($40,$44,$4E,$5F,$44,$4E,$40); Size:$86),
  {07h} (Data:($4C,$54,$44,$44,$44,$47,$43); Size:$86),
  {08h} (Data:($40,$40,$40,$40,$40,$40,$40); Size:$86),
  {09h} (Data:($40,$4E,$51,$51,$51,$4E,$40); Size:$86),
  {0Ah} (Data:($40,$40,$40,$40,$40,$40,$40); Size:$86),
  {0Bh} (Data:($40,$5C,$58,$57,$45,$47,$40); Size:$86),
  {0Ch} (Data:($20,$27,$25,$27,$22,$27,$22); Size:$85),
  {0Dh} (Data:($40,$40,$40,$40,$40,$40,$40); Size:$86),
  {0Eh} (Data:($5E,$52,$5E,$52,$52,$52,$49); Size:$86),
  {0Fh} (Data:($40,$55,$4E,$5B,$4E,$55,$40); Size:$86),
  {10h} (Data:($40,$41,$47,$5F,$47,$41,$40); Size:$86),
  {11h} (Data:($40,$50,$5C,$5F,$5C,$50,$40); Size:$86),
  {12h} (Data:($44,$4E,$5F,$44,$5F,$4E,$44); Size:$86),
  {13h} (Data:($25,$25,$25,$25,$25,$20,$25); Size:$85),
  {14h} (Data:($5E,$55,$55,$5E,$54,$54,$54); Size:$86),
  {15h} (Data:($16,$11,$12,$15,$12,$14,$13); Size:$84),
  {16h} (Data:($40,$40,$40,$40,$5F,$5F,$5F); Size:$86),
  {17h} (Data:($44,$4E,$5F,$44,$5F,$4E,$5F); Size:$86),
  {18h} (Data:($44,$4E,$5F,$44,$44,$44,$44); Size:$86),
  {19h} (Data:($44,$44,$44,$44,$5F,$4E,$44); Size:$86),
  {1Ah} (Data:($40,$44,$48,$5F,$48,$44,$40); Size:$86),
  {1Bh} (Data:($40,$44,$42,$5F,$42,$44,$40); Size:$86),
  {1Ch} (Data:($40,$40,$41,$41,$5F,$40,$40); Size:$86),
  {1Dh} (Data:($40,$40,$4A,$5F,$4A,$40,$40); Size:$86),
  {1Eh} (Data:($40,$44,$44,$4E,$4E,$5F,$40); Size:$86),
  {1Fh} (Data:($40,$5F,$4E,$4E,$44,$44,$40); Size:$86),
  {20h} (Data:($40,$40,$40,$40,$40,$40,$40); Size:$86),
  {21h} (Data:($22,$27,$27,$22,$22,$20,$22); Size:$85),
  {22h} (Data:($15,$15,$10,$10,$10,$10,$10); Size:$84),
  {23h} (Data:($40,$4A,$5F,$4A,$5F,$4A,$40); Size:$86),
  {24h} (Data:($44,$4E,$45,$4E,$54,$4E,$44); Size:$86),
  {25h} (Data:($40,$51,$48,$44,$42,$51,$40); Size:$86),
  {26h} (Data:($46,$49,$46,$5D,$49,$49,$56); Size:$86),
  {27h} (Data:($22,$22,$21,$20,$20,$20,$20); Size:$85),
  {28h} (Data:($14,$12,$11,$11,$11,$12,$14); Size:$84),
  {29h} (Data:($11,$12,$14,$14,$14,$12,$11); Size:$84),
  {2Ah} (Data:($40,$51,$4A,$5F,$4A,$51,$40); Size:$86),
  {2Bh} (Data:($20,$20,$22,$27,$22,$20,$20); Size:$85),
  {2Ch} (Data:($20,$20,$20,$20,$22,$22,$21); Size:$85),
  {2Dh} (Data:($20,$20,$20,$27,$20,$20,$20); Size:$85),
  {2Eh} (Data:($10,$10,$10,$10,$10,$11,$10); Size:$84),
  {2Fh} (Data:($40,$50,$48,$44,$42,$41,$40); Size:$86),
  {30h} (Data:($4E,$51,$59,$55,$53,$51,$4E); Size:$86),
  {31h} (Data:($12,$13,$12,$12,$12,$12,$17); Size:$84),
  {32h} (Data:($4E,$51,$50,$48,$44,$42,$5F); Size:$86),
  {33h} (Data:($4E,$51,$50,$4E,$50,$51,$4E); Size:$86),
  {34h} (Data:($48,$4C,$4A,$49,$5F,$48,$48); Size:$86),
  {35h} (Data:($5F,$41,$41,$4F,$50,$50,$4F); Size:$86),
  {36h} (Data:($4E,$51,$41,$4F,$51,$51,$4E); Size:$86),
  {37h} (Data:($5F,$50,$50,$48,$44,$44,$44); Size:$86),
  {38h} (Data:($4E,$51,$51,$4E,$51,$51,$4E); Size:$86),
  {39h} (Data:($4E,$51,$51,$5E,$50,$51,$4E); Size:$86),
  {3Ah} (Data:($10,$10,$11,$10,$10,$11,$10); Size:$84),
  {3Bh} (Data:($20,$20,$22,$20,$22,$21,$20); Size:$85),
  {3Ch} (Data:($28,$24,$22,$21,$22,$24,$28); Size:$85),
  {3Dh} (Data:($20,$20,$27,$20,$27,$20,$20); Size:$85),
  {3Eh} (Data:($21,$22,$24,$28,$24,$22,$21); Size:$85),
  {3Fh} (Data:($4E,$51,$50,$48,$44,$40,$44); Size:$86),
  {40h} (Data:($4E,$51,$5D,$4D,$41,$41,$4E); Size:$86),
  {41h} (Data:($4E,$51,$51,$5F,$51,$51,$51); Size:$86),
  {42h} (Data:($4F,$51,$51,$4F,$51,$51,$4F); Size:$86),
  {43h} (Data:($4E,$51,$41,$41,$41,$51,$4E); Size:$86),
  {44h} (Data:($4F,$51,$51,$51,$51,$51,$4F); Size:$86),
  {45h} (Data:($5F,$41,$41,$4F,$41,$41,$5F); Size:$86),
  {46h} (Data:($5F,$41,$41,$4F,$41,$41,$41); Size:$86),
  {47h} (Data:($4E,$51,$41,$41,$59,$51,$4E); Size:$86),
  {48h} (Data:($51,$51,$51,$5F,$51,$51,$51); Size:$86),
  {49h} (Data:($17,$12,$12,$12,$12,$12,$17); Size:$84),
  {4Ah} (Data:($50,$50,$50,$50,$50,$51,$4E); Size:$86),
  {4Bh} (Data:($51,$49,$45,$43,$45,$49,$51); Size:$86),
  {4Ch} (Data:($41,$41,$41,$41,$41,$41,$5F); Size:$86),
  {4Dh} (Data:($51,$5B,$55,$51,$51,$51,$51); Size:$86),
  {4Eh} (Data:($51,$51,$53,$55,$59,$51,$51); Size:$86),
  {4Fh} (Data:($4E,$51,$51,$51,$51,$51,$4E); Size:$86),
  {50h} (Data:($4F,$51,$51,$4F,$41,$41,$41); Size:$86),
  {51h} (Data:($4E,$51,$51,$51,$51,$49,$56); Size:$86),
  {52h} (Data:($4F,$51,$51,$4F,$51,$51,$51); Size:$86),
  {53h} (Data:($5E,$41,$41,$4E,$50,$50,$4F); Size:$86),
  {54h} (Data:($5F,$44,$44,$44,$44,$44,$44); Size:$86),
  {55h} (Data:($51,$51,$51,$51,$51,$51,$4E); Size:$86),
  {56h} (Data:($51,$51,$51,$51,$4A,$4A,$44); Size:$86),
  {57h} (Data:($51,$51,$51,$51,$55,$55,$4A); Size:$86),
  {58h} (Data:($51,$51,$4A,$44,$4A,$51,$51); Size:$86),
  {59h} (Data:($51,$51,$51,$4E,$44,$44,$44); Size:$86),
  {5Ah} (Data:($5F,$50,$48,$44,$42,$41,$5F); Size:$86),
  {5Bh} (Data:($0B,$09,$09,$09,$09,$09,$0B); Size:$83),
  {5Ch} (Data:($40,$41,$42,$44,$48,$50,$40); Size:$86),
  {5Dh} (Data:($0B,$0A,$0A,$0A,$0A,$0A,$0B); Size:$83),
  {5Eh} (Data:($22,$25,$20,$20,$20,$20,$20); Size:$85),
  {5Fh} (Data:($40,$40,$40,$40,$40,$5F,$40); Size:$86),
  {60h} (Data:($11,$12,$10,$10,$10,$10,$10); Size:$84),
  {61h} (Data:($40,$40,$4E,$51,$51,$59,$56); Size:$86),
  {62h} (Data:($41,$41,$4F,$51,$51,$51,$4F); Size:$86),
  {63h} (Data:($40,$40,$4E,$51,$41,$51,$4E); Size:$86),
  {64h} (Data:($50,$50,$5E,$51,$51,$51,$5E); Size:$86),
  {65h} (Data:($40,$40,$4E,$51,$5F,$41,$4E); Size:$86),
  {66h} (Data:($24,$2A,$22,$27,$22,$22,$22); Size:$85),
  {67h} (Data:($40,$40,$4E,$51,$5E,$50,$4E); Size:$86),
  {68h} (Data:($21,$21,$27,$29,$29,$29,$29); Size:$85),
  {69h} (Data:($12,$10,$13,$12,$12,$12,$17); Size:$84),
  {6Ah} (Data:($28,$20,$28,$28,$28,$29,$26); Size:$85),
  {6Bh} (Data:($21,$21,$29,$25,$23,$25,$29); Size:$85),
  {6Ch} (Data:($13,$12,$12,$12,$12,$12,$17); Size:$84),
  {6Dh} (Data:($40,$40,$4B,$55,$51,$51,$51); Size:$86),
  {6Eh} (Data:($40,$40,$4F,$51,$51,$51,$51); Size:$86),
  {6Fh} (Data:($40,$40,$4E,$51,$51,$51,$4E); Size:$86),
  {70h} (Data:($40,$40,$4F,$51,$4F,$41,$41); Size:$86),
  {71h} (Data:($40,$40,$5E,$51,$5E,$50,$50); Size:$86),
  {72h} (Data:($40,$40,$4D,$53,$41,$41,$41); Size:$86),
  {73h} (Data:($40,$40,$5E,$41,$4E,$50,$4F); Size:$86),
  {74h} (Data:($12,$12,$17,$12,$12,$12,$16); Size:$84),
  {75h} (Data:($40,$40,$49,$49,$49,$49,$56); Size:$86),
  {76h} (Data:($40,$40,$51,$51,$4A,$4A,$44); Size:$86),
  {77h} (Data:($40,$40,$51,$51,$51,$55,$4A); Size:$86),
  {78h} (Data:($40,$40,$51,$4A,$44,$4A,$51); Size:$86),
  {79h} (Data:($40,$40,$51,$51,$5E,$50,$4E); Size:$86),
  {7Ah} (Data:($40,$40,$5F,$49,$44,$52,$5F); Size:$86),
  {7Bh} (Data:($14,$12,$12,$13,$12,$12,$14); Size:$84),
  {7Ch} (Data:($11,$11,$11,$10,$11,$11,$11); Size:$84),
  {7Dh} (Data:($11,$12,$12,$14,$12,$12,$11); Size:$84),
  {7Eh} (Data:($40,$56,$49,$40,$40,$40,$40); Size:$86),
  {7Fh} (Data:($40,$44,$4A,$51,$51,$5F,$40); Size:$86),
  {80h} (Data:($4E,$51,$41,$41,$51,$4E,$44); Size:$86),
  {81h} (Data:($4A,$40,$51,$51,$51,$51,$4E); Size:$86),
  {82h} (Data:($5C,$40,$5F,$41,$4F,$41,$5F); Size:$86),
  {83h} (Data:($4E,$40,$4E,$51,$5F,$51,$51); Size:$86),
  {84h} (Data:($4A,$40,$4E,$51,$5F,$51,$51); Size:$86),
  {85h} (Data:($47,$40,$4E,$51,$5F,$51,$51); Size:$86),
  {86h} (Data:($44,$40,$4E,$51,$5F,$51,$51); Size:$86),
  {87h} (Data:($40,$40,$5E,$41,$41,$5E,$44); Size:$86),
  {88h} (Data:($4E,$40,$5F,$41,$4F,$41,$5F); Size:$86),
  {89h} (Data:($4A,$40,$5F,$41,$4F,$41,$5F); Size:$86),
  {8Ah} (Data:($47,$40,$5F,$41,$4F,$41,$5F); Size:$86),
  {8Bh} (Data:($25,$20,$22,$22,$22,$22,$22); Size:$85),
  {8Ch} (Data:($27,$20,$22,$22,$22,$22,$22); Size:$85),
  {8Dh} (Data:($47,$40,$44,$44,$44,$44,$44); Size:$86),
  {8Eh} (Data:($4A,$40,$4E,$51,$5F,$51,$51); Size:$86),
  {8Fh} (Data:($44,$44,$40,$4E,$51,$5F,$51); Size:$86),
  {90h} (Data:($5C,$40,$5F,$41,$4F,$41,$5F); Size:$86),
  {91h} (Data:($40,$5F,$44,$4E,$45,$45,$5E); Size:$86),
  {92h} (Data:($5E,$45,$45,$5F,$45,$45,$5D); Size:$86),
  {93h} (Data:($4E,$40,$4E,$51,$51,$51,$4E); Size:$86),
  {94h} (Data:($4A,$40,$4E,$51,$51,$51,$4E); Size:$86),
  {95h} (Data:($47,$40,$4E,$51,$51,$51,$4E); Size:$86),
  {96h} (Data:($4E,$40,$51,$51,$51,$51,$4E); Size:$86),
  {97h} (Data:($47,$40,$51,$51,$51,$51,$4E); Size:$86),
  {98h} (Data:($4A,$40,$51,$51,$4E,$44,$44); Size:$86),
  {99h} (Data:($4A,$40,$4E,$51,$51,$51,$4E); Size:$86),
  {9Ah} (Data:($4A,$40,$51,$51,$51,$51,$4E); Size:$86),
  {9Bh} (Data:($24,$2E,$21,$21,$21,$2E,$24); Size:$85),
  {9Ch} (Data:($44,$4A,$42,$4F,$42,$52,$5F); Size:$86),
  {9Dh} (Data:($51,$51,$4E,$55,$44,$4E,$44); Size:$86),
  {9Eh} (Data:($4F,$51,$4F,$41,$49,$5D,$49); Size:$86),
  {9Fh} (Data:($48,$54,$44,$4E,$44,$45,$42); Size:$86),
  {A0h} (Data:($5C,$40,$4E,$51,$5F,$51,$51); Size:$86),
  {A1h} (Data:($17,$10,$11,$11,$11,$11,$11); Size:$84),
  {A2h} (Data:($5C,$40,$4E,$51,$51,$51,$4E); Size:$86),
  {A3h} (Data:($5C,$40,$51,$51,$51,$51,$4E); Size:$86),
  {A4h} (Data:($4E,$40,$51,$53,$55,$59,$51); Size:$86),
  {A5h} (Data:($4E,$40,$51,$53,$55,$59,$51); Size:$86),
  {A6h} (Data:($4E,$51,$59,$56,$40,$4E,$40); Size:$86),
  {A7h} (Data:($4E,$51,$51,$4E,$40,$4E,$40); Size:$86),
  {A8h} (Data:($44,$40,$44,$42,$41,$51,$4E); Size:$86),
  {A9h} (Data:($20,$20,$2F,$21,$21,$20,$20); Size:$85),
  {AAh} (Data:($40,$40,$4F,$48,$48,$40,$40); Size:$86),
  {ABh} (Data:($51,$50,$48,$44,$42,$51,$51); Size:$86),
  {ACh} (Data:($51,$50,$48,$44,$42,$59,$59); Size:$86),
  {ADh} (Data:($11,$11,$10,$11,$11,$11,$11); Size:$84),
  {AEh} (Data:($40,$40,$52,$49,$52,$40,$40); Size:$86),
  {AFh} (Data:($40,$40,$49,$52,$49,$40,$40); Size:$86),
  {B0h} (Data:($51,$44,$51,$44,$51,$44,$51); Size:$86),
  {B1h} (Data:($55,$4A,$55,$4A,$55,$4A,$55); Size:$86),
  {B2h} (Data:($56,$5B,$56,$5F,$56,$5B,$56); Size:$86),
  {B3h} (Data:($05,$05,$05,$05,$05,$05,$05); Size:$82),
  {B4h} (Data:($14,$14,$14,$17,$14,$14,$14); Size:$84),
  {B5h} (Data:($14,$14,$17,$14,$17,$14,$14); Size:$84),
  {B6h} (Data:($2A,$2A,$2A,$2B,$2A,$2A,$2A); Size:$85),
  {B7h} (Data:($40,$40,$40,$4F,$4A,$4A,$4A); Size:$86),
  {B8h} (Data:($40,$40,$47,$44,$47,$44,$44); Size:$86),
  {B9h} (Data:($2A,$2A,$2B,$28,$2B,$2A,$2A); Size:$85),
  {BAh} (Data:($15,$15,$15,$15,$15,$15,$15); Size:$84),
  {BBh} (Data:($40,$40,$4F,$48,$4B,$4A,$4A); Size:$86),
  {BCh} (Data:($4A,$4A,$4B,$48,$4F,$40,$40); Size:$86),
  {BDh} (Data:($4A,$4A,$4A,$4F,$40,$40,$40); Size:$86),
  {BEh} (Data:($44,$44,$47,$44,$47,$40,$40); Size:$86),
  {BFh} (Data:($40,$40,$40,$47,$44,$44,$44); Size:$86),
  {C0h} (Data:($11,$11,$11,$17,$10,$10,$10); Size:$84),
  {C1h} (Data:($44,$44,$44,$5F,$40,$40,$40); Size:$86),
  {C2h} (Data:($40,$40,$40,$5F,$44,$44,$44); Size:$86),
  {C3h} (Data:($11,$11,$11,$17,$11,$11,$11); Size:$84),
  {C4h} (Data:($40,$40,$40,$5F,$40,$40,$40); Size:$86),
  {C5h} (Data:($44,$44,$44,$5F,$44,$44,$44); Size:$86),
  {C6h} (Data:($11,$11,$17,$11,$17,$11,$11); Size:$84),
  {C7h} (Data:($25,$25,$25,$2D,$25,$25,$25); Size:$85),
  {C8h} (Data:($25,$25,$2D,$21,$2F,$20,$20); Size:$85),
  {C9h} (Data:($20,$20,$2F,$21,$2D,$25,$25); Size:$85),
  {CAh} (Data:($4A,$4A,$5B,$40,$5F,$40,$40); Size:$86),
  {CBh} (Data:($40,$40,$5F,$40,$5B,$4A,$4A); Size:$86),
  {CCh} (Data:($25,$25,$2D,$21,$2D,$25,$25); Size:$85),
  {CDh} (Data:($40,$40,$5F,$40,$5F,$40,$40); Size:$86),
  {CEh} (Data:($4A,$4A,$5B,$40,$5B,$4A,$4A); Size:$86),
  {CFh} (Data:($44,$44,$5F,$40,$5F,$40,$40); Size:$86),
  {D0h} (Data:($4A,$4A,$4A,$5F,$40,$40,$40); Size:$86),
  {D1h} (Data:($40,$40,$5F,$40,$5F,$44,$44); Size:$86),
  {D2h} (Data:($40,$40,$40,$5F,$4A,$4A,$4A); Size:$86),
  {D3h} (Data:($25,$25,$25,$2F,$20,$20,$20); Size:$85),
  {D4h} (Data:($11,$11,$17,$11,$17,$10,$10); Size:$84),
  {D5h} (Data:($10,$10,$17,$11,$17,$11,$11); Size:$84),
  {D6h} (Data:($20,$20,$20,$2F,$25,$25,$25); Size:$85),
  {D7h} (Data:($4A,$4A,$4A,$5F,$4A,$4A,$4A); Size:$86),
  {D8h} (Data:($44,$44,$5F,$44,$5F,$44,$44); Size:$86),
  {D9h} (Data:($48,$48,$48,$4F,$40,$40,$40); Size:$86),
  {DAh} (Data:($40,$40,$5F,$41,$41,$40,$40); Size:$86),
  {DBh} (Data:($5F,$5F,$5F,$5F,$5F,$5F,$5F); Size:$86),
  {DCh} (Data:($40,$40,$40,$40,$5F,$5F,$5F); Size:$86),
  {DDh} (Data:($0B,$0B,$0B,$0B,$0B,$0B,$0B); Size:$83),
  {DEh} (Data:($17,$17,$17,$17,$17,$17,$17); Size:$84),
  {DFh} (Data:($5F,$5F,$5F,$40,$40,$40,$40); Size:$86),
  {E0h} (Data:($40,$56,$49,$49,$49,$56,$40); Size:$86),
  {E1h} (Data:($40,$4E,$51,$5F,$51,$4F,$41); Size:$86),
  {E2h} (Data:($40,$5F,$51,$41,$41,$41,$40); Size:$86),
  {E3h} (Data:($40,$5F,$4A,$4A,$4A,$4A,$40); Size:$86),
  {E4h} (Data:($5F,$51,$42,$44,$42,$51,$5F); Size:$86),
  {E5h} (Data:($40,$5E,$49,$49,$49,$46,$40); Size:$86),
  {E6h} (Data:($40,$52,$52,$52,$52,$4E,$41); Size:$86),
  {E7h} (Data:($40,$56,$4D,$44,$44,$44,$44); Size:$86),
  {E8h} (Data:($5F,$44,$4A,$4A,$4A,$44,$5F); Size:$86),
  {E9h} (Data:($4E,$51,$51,$5F,$51,$51,$4E); Size:$86),
  {EAh} (Data:($4E,$51,$51,$51,$4A,$4A,$5B); Size:$86),
  {EBh} (Data:($5C,$44,$48,$5E,$51,$51,$4E); Size:$86),
  {ECh} (Data:($40,$4E,$55,$55,$55,$4E,$40); Size:$86),
  {EDh} (Data:($50,$4E,$55,$55,$55,$4E,$41); Size:$86),
  {EEh} (Data:($2C,$22,$21,$27,$21,$22,$2C); Size:$85),
  {EFh} (Data:($4E,$51,$51,$51,$51,$51,$51); Size:$86),
  {F0h} (Data:($40,$5F,$40,$5F,$40,$5F,$40); Size:$86),
  {F1h} (Data:($20,$22,$27,$22,$20,$27,$20); Size:$85),
  {F2h} (Data:($21,$22,$24,$22,$21,$20,$27); Size:$85),
  {F3h} (Data:($24,$22,$21,$22,$24,$20,$27); Size:$85),
  {F4h} (Data:($12,$15,$15,$11,$11,$11,$11); Size:$84),
  {F5h} (Data:($14,$14,$14,$14,$15,$15,$12); Size:$84),
  {F6h} (Data:($20,$22,$20,$27,$20,$22,$20); Size:$85),
  {F7h} (Data:($40,$56,$49,$40,$56,$49,$40); Size:$86),
  {F8h} (Data:($4E,$51,$51,$4E,$40,$40,$40); Size:$86),
  {F9h} (Data:($10,$10,$10,$10,$11,$10,$10); Size:$84),
  {FAh} (Data:($10,$10,$10,$10,$11,$10,$10); Size:$84),
  {FBh} (Data:($58,$48,$48,$48,$49,$4A,$4C); Size:$86),
  {FCh} (Data:($4D,$53,$51,$51,$40,$40,$40); Size:$86),
  {FDh} (Data:($23,$24,$22,$21,$27,$20,$20); Size:$85),
  {FEh} (Data:($20,$20,$27,$27,$27,$20,$20); Size:$85),
  {FFh} (Data:($40,$40,$40,$40,$40,$40,$40); Size:$86)
 );


function OutText(ix,iy:word; s:string):integer;
 var
  c:byte;
  x:integer;
  o:word;
  data:byte;
  l:integer;
 begin
  for c:=1 to length(s) do begin

   o:=80*iy;

   for l:=1 to 7 do begin

    data:=font[s[c]].data[l];
    x:=ix;

    Repeat

    { TextColor }
     while odd(data) do begin
      port[$3c4]:=2;
      port[$3c5]:=1 shl (x and 3);
      mem[$A000:o+(x div 4)]:=TextColor;
      inc(x);
      data:=data shr 1;
     end;
    { BackColor }
     Repeat
      port[$3c4]:=2;
      port[$3c5]:=1 shl (x and 3);
      mem[$A000:o+(x div 4)]:=BackColor;
      inc(x);
      data:=data shr 1;
     Until Odd(Data);

    Until Data=1;

    inc(o,80);

   end;

   inc(ix,font[s[c]].size and 127);

  end;

  OutText:=ix;

 end;

end.